include:
  - project: va1erify-gitlab-ci/gitlab-terraform-ci
    file: .terraform-gitlab.yml
    ref: "v1.0.0"
  - project: va1erify-deusops/task-26-01-2024/hard-gitlab-variables
    file: variables.yml
    ref: "main"

stages:
  - validate
  - build
  - deploy-infrastructure
  - cleanup

variables:
  TF_ROOT: $INFRASTRUCTURE_TF_ROOT
  TF_STATE_NAME: $INFRASTRUCTURE_TF_STATE_NAME
  CLOUD_ID: $YC_CLOUD_ID
  FOLDER_ID: $YC_FOLDER_ID
  TOKEN: $TOKEN


before_script:
  - cat terraformrc.config > ~/.terraformrc

fmt:
  extends: .terraform:fmt
  needs: [ ]

validate:
  extends: .terraform:validate
  needs: [ ]

build:
  extends: .terraform:build
  environment:
    name: $TF_STATE_NAME
    action: prepare
  rules:
    - when: manual

deploy-infrastructure:
  extends: .terraform:deploy
  environment:
    name: $TF_STATE_NAME
    action: start
  rules:
    - when: manual
  after_script:
    - gitlab-terraform output -json
    - gitlab-terraform output -json > terraform_outputs.json
  artifacts:
    paths:
      - terraform_outputs.json

cleanup:
  extends: .terraform:destroy
  dependencies:
    - cleanup
  needs: [ ]
  rules:
    - when: manual